#!/bin/bash

#os判斷
if [ -f "/etc/redhat-release" ]; then
        os=$(cat /etc/redhat-release | awk -F 'release' '{print $2}' | awk -F '.' '{print $1}' | sed s/[[:space:]]//g)
else
        os=$(cat /etc/lsb-release |grep 'DISTRIB_RELEASE' |awk -F '=' '{print $2 }')
        os_linux="Ubuntu"
fi

#判斷是否使用litespeed

if ps ax | grep -v grep | grep 'litespeed' >/dev/null; then
	echo "litespeed主機無法安裝"
	exit
fi

#更改apache預設port為80
whmapi1 set_tweaksetting key=apache_port value=0.0.0.0:80

# 判斷 CentOS 版本，關閉相關服務

if [[ "${os}" == "6" ]]; then
	echo "===================================================================================================="
	echo "			此主機作業系統為 CentOS 6 "
	echo "===================================================================================================="
	#!/bin/bash

	if ps ax | grep -v grep | grep 'openresty' >/dev/null; then

		/etc/init.d/nginx stop
		/sbin/chkconfig nginx off

		if [[ -f "/etc/init.d/nginx" ]]; then
			mv /etc/init.d/nginx /etc/init.d/nginxbak
		fi
		echo "關閉openresty 完成 "
	else
		echo "openresty 未執行"
		/sbin/chkconfig nginx off
		if [[ -f "/etc/init.d/nginx" ]]; then
			mv /etc/init.d/nginx /etc/init.d/nginxbak
		fi
	fi
	echo "   "

elif [[ "${os}" == "7" || "${os}" == "8" ]]; then
	echo "===================================================================================================="
	echo "			此主機作業系統為 CentOS 7 or 8"
	echo "===================================================================================================="
	if ps ax | grep -v grep | grep 'openresty' >/dev/null; then
		systemctl disable openresty.service
		systemctl stop openresty.service
		echo "關閉openresty 完成"
	else
		echo "openresty 未執行"
		systemctl disable openresty.service
	fi
	echo "   "

else
	echo "!!! os 參數錯誤，請確認主機作業系統 !!!"
	exit
fi

#安裝nginx
yum install -y ea-nginx ea-nginx-gzip

#關閉cache
sed -i 's/"enabled" : true,/"enabled" : false,/g' /etc/nginx/ea-nginx/cache.json

#gizp參數修正
sed -i 's/gzip_min_length 256;/gzip_min_length 384;/g' /etc/nginx/conf.d/gzip.conf
sed -i 's/gzip_comp_level 5;/gzip_comp_level 2;/g' /etc/nginx/conf.d/gzip.conf
sed -i 's/gzip_disable "msie6";/gzip_disable "MSIE [1-6]\\.";/g' /etc/nginx/conf.d/gzip.conf

#參數修正
sed -i 's/worker_processes 1/worker_processes  10/g' /etc/nginx/nginx.conf
sed -i 's/worker_connections  1024/worker_connections  5120/g' /etc/nginx/nginx.conf
sed -i 's/worker_rlimit_nofile 65536/worker_rlimit_nofile 16384/g' /etc/nginx/nginx.conf
sed -i '/worker_connections/a\  use epoll;' /etc/nginx/nginx.conf


#更新file阻擋規則
echo '
location = /xmlrpc.php {
limit_req zone=one burst=2 nodelay;
include conf.d/includes-optional/cpanel-proxy.conf;
proxy_pass $CPANEL_APACHE_PROXY_PASS;
}' >>/etc/nginx/conf.d/server-includes/custom_limit.conf

echo '
location = /wp-login.php {
limit_req zone=one burst=2 nodelay;
include conf.d/includes-optional/cpanel-proxy.conf;
proxy_pass $CPANEL_APACHE_PROXY_PASS;
}' >>/etc/nginx/conf.d/server-includes/custom_limit.conf

#更新自定參數
echo '
limit_req_zone $binary_remote_addr zone=one:10m rate=15r/m;
proxy_read_timeout 150;
proxy_connect_timeout  150;
proxy_buffers  64 512k;
proxy_buffer_size  1m;
proxy_busy_buffers_size  1m;
client_body_timeout 300;
client_body_buffer_size 30M;
' >/etc/nginx/conf.d/limits.conf

echo '
{
   "worker_processes": "10",
   "apache_port" : "81",
   "apache_port_ip" : "127.0.0.1",
   "apache_ssl_port" : "444",
   "apache_ssl_port_ip" : "127.0.0.1",
   "client_max_body_size" : "128m",
   "worker_connections" : "5000"
}
' >/etc/nginx/ea-nginx/settings.json

echo '
{
# do not serve Apache .htaccess files
location ~ /\.htaccess {
    deny all;
    log_not_found off;
    access_log off;
    return 404;
}
' >/etc/nginx/conf.d/server-includes/cpanel-static-locations.conf



#重reload設定
/scripts/ea-nginx config --all
/usr/local/cpanel/scripts/ea-nginx reload

#關閉cpanel客戶功能
echo 'toggle_nginx_caching=0' >>/var/cpanel/features/disabled
